<a id="types-aiobotocore-ssm-contacts"></a>

# types-aiobotocore-ssm-contacts

[![PyPI - types-aiobotocore-ssm-contacts](https://img.shields.io/pypi/v/types-aiobotocore-ssm-contacts.svg?color=blue)](https://pypi.org/project/types-aiobotocore-ssm-contacts)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-ssm-contacts.svg?color=blue)](https://pypi.org/project/types-aiobotocore-ssm-contacts)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-ssm-contacts?color=blue)](https://pypistats.org/packages/types-aiobotocore-ssm-contacts)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.SSMContacts 2.3.1](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/ssm-contacts.html#SSMContacts)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.5.14](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-ssm-contacts docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ssm_contacts/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-ssm-contacts](#types-aiobotocore-ssm-contacts)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SSMContacts`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `SSMContacts` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[ssm-contacts]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[ssm-contacts]'


# standalone installation
python -m pip install types-aiobotocore-ssm-contacts
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-ssm-contacts
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[ssm-contacts]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm-contacts]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[ssm-contacts]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[ssm-contacts]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm-contacts]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[ssm-contacts]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[ssm-contacts]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[ssm-contacts]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm-contacts]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[ssm-contacts]` in your environment:

```bash
python -m pip install 'types-aiobotocore[ssm-contacts]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SSMContactsClient` provides annotations for
`session.create_client("ssm-contacts")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_ssm_contacts import SSMContactsClient

session = get_session()
async with session.create_client("ssm-contacts") as client:
    client: SSMContactsClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_ssm_contacts.paginator` module contains type annotations for
all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_ssm_contacts import SSMContactsClient
from types_aiobotocore_ssm_contacts.paginator import (
    ListContactChannelsPaginator,
    ListContactsPaginator,
    ListEngagementsPaginator,
    ListPageReceiptsPaginator,
    ListPagesByContactPaginator,
    ListPagesByEngagementPaginator,
)

session = get_session()
async with session.create_client("ssm-contacts") as client:
    client: SSMContactsClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_contact_channels_paginator: ListContactChannelsPaginator = client.get_paginator("list_contact_channels")
        list_contacts_paginator: ListContactsPaginator = client.get_paginator("list_contacts")
        list_engagements_paginator: ListEngagementsPaginator = client.get_paginator("list_engagements")
        list_page_receipts_paginator: ListPageReceiptsPaginator = client.get_paginator("list_page_receipts")
        list_pages_by_contact_paginator: ListPagesByContactPaginator = client.get_paginator("list_pages_by_contact")
        list_pages_by_engagement_paginator: ListPagesByEngagementPaginator = client.get_paginator("list_pages_by_engagement")
    ```







### Literals

`types_aiobotocore_ssm_contacts.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_ssm_contacts.literals import (
    AcceptCodeValidationType,
    AcceptTypeType,
    ActivationStatusType,
    ChannelTypeType,
    ContactTypeType,
    ListContactChannelsPaginatorName,
    ListContactsPaginatorName,
    ListEngagementsPaginatorName,
    ListPageReceiptsPaginatorName,
    ListPagesByContactPaginatorName,
    ListPagesByEngagementPaginatorName,
    ReceiptTypeType,
    SSMContactsServiceName,
    ServiceName,
    ResourceServiceName,
    PaginatorName,
)

def check_value(value: AcceptCodeValidationType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_ssm_contacts.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_ssm_contacts.type_defs import (
    AcceptPageRequestRequestTypeDef,
    ActivateContactChannelRequestRequestTypeDef,
    ChannelTargetInfoTypeDef,
    ContactChannelAddressTypeDef,
    ContactChannelTypeDef,
    ContactTargetInfoTypeDef,
    ContactTypeDef,
    CreateContactChannelRequestRequestTypeDef,
    CreateContactChannelResultTypeDef,
    CreateContactRequestRequestTypeDef,
    CreateContactResultTypeDef,
    DeactivateContactChannelRequestRequestTypeDef,
    DeleteContactChannelRequestRequestTypeDef,
    DeleteContactRequestRequestTypeDef,
    DescribeEngagementRequestRequestTypeDef,
    DescribeEngagementResultTypeDef,
    DescribePageRequestRequestTypeDef,
    DescribePageResultTypeDef,
    EngagementTypeDef,
    GetContactChannelRequestRequestTypeDef,
    GetContactChannelResultTypeDef,
    GetContactPolicyRequestRequestTypeDef,
    GetContactPolicyResultTypeDef,
    GetContactRequestRequestTypeDef,
    GetContactResultTypeDef,
    ListContactChannelsRequestListContactChannelsPaginateTypeDef,
    ListContactChannelsRequestRequestTypeDef,
    ListContactChannelsResultTypeDef,
    ListContactsRequestListContactsPaginateTypeDef,
    ListContactsRequestRequestTypeDef,
    ListContactsResultTypeDef,
    ListEngagementsRequestListEngagementsPaginateTypeDef,
    ListEngagementsRequestRequestTypeDef,
    ListEngagementsResultTypeDef,
    ListPageReceiptsRequestListPageReceiptsPaginateTypeDef,
    ListPageReceiptsRequestRequestTypeDef,
    ListPageReceiptsResultTypeDef,
    ListPagesByContactRequestListPagesByContactPaginateTypeDef,
    ListPagesByContactRequestRequestTypeDef,
    ListPagesByContactResultTypeDef,
    ListPagesByEngagementRequestListPagesByEngagementPaginateTypeDef,
    ListPagesByEngagementRequestRequestTypeDef,
    ListPagesByEngagementResultTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResultTypeDef,
    PageTypeDef,
    PaginatorConfigTypeDef,
    PlanTypeDef,
    PutContactPolicyRequestRequestTypeDef,
    ReceiptTypeDef,
    ResponseMetadataTypeDef,
    SendActivationCodeRequestRequestTypeDef,
    StageTypeDef,
    StartEngagementRequestRequestTypeDef,
    StartEngagementResultTypeDef,
    StopEngagementRequestRequestTypeDef,
    TagResourceRequestRequestTypeDef,
    TagTypeDef,
    TargetTypeDef,
    TimeRangeTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateContactChannelRequestRequestTypeDef,
    UpdateContactRequestRequestTypeDef,
)

def get_structure() -> AcceptPageRequestRequestTypeDef:
    return {
      ...
    }
```

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

## What's new

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

## Versioning

`types-aiobotocore-ssm-contacts` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_ssm_contacts/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
